char incomingByte; 

//int  LED = 12; 

int i[9] = {0,0,0,0,0,0};

boolean mt[8];

struct MOTOR    // структура для хранения номеров pin-ов, к которым подключены моторчики
{
  int in1;      // INPUT1
  int in2;      // INPUT2
};

// определяем порты, к которым подключены моторчики
MOTOR MOTOR1 = { 5,  6};
MOTOR MOTOR2 = { 7, 8};
 
void setup() {
  Serial.begin(9600); 
  pinMode(MOTOR1.in1, OUTPUT); // настраиваем выводы
  pinMode(MOTOR1.in2, OUTPUT); // на ВЫВОД
  pinMode(MOTOR2.in1, OUTPUT);
  pinMode(MOTOR2.in2, OUTPUT);
  //pinMode(LED, OUTPUT);
}

void forward1() // первый вперёд
{
  digitalWrite(MOTOR1.in1, HIGH);
  digitalWrite(MOTOR1.in2, LOW);
}

void forward2() // второй вперёд
{
  digitalWrite(MOTOR2.in1, HIGH);
  digitalWrite(MOTOR2.in2, LOW);
}

void back1() // первый назад
{
  digitalWrite(MOTOR1.in1, LOW);
  digitalWrite(MOTOR1.in2, HIGH);
}

void back2() // второй назад
{
  digitalWrite(MOTOR2.in1, LOW);
  digitalWrite(MOTOR2.in2, HIGH);
}

void stop12() // второй назад
{
  digitalWrite(MOTOR2.in1, LOW);
  digitalWrite(MOTOR2.in2, LOW);
  digitalWrite(MOTOR1.in1, LOW);
  digitalWrite(MOTOR1.in2, LOW);
}
 
void loop() {
  if (Serial.available() > 0) {  
    incomingByte = Serial.read(); 
    if(incomingByte == '4' && mt[3] == false) {
       mt[3] = true;
    }else mt[3] = false;
    if(incomingByte == '3' && mt[2] == false) {
       mt[2] = true;
    }else mt[2] = false;
    if(incomingByte == '5' && mt[0] == false) {
       mt[0] = true;
    }else mt[0] = false;
    if(incomingByte == '1' && mt[1] == false) {
       mt[1] = true;
    }else mt[1] = false;
    if(incomingByte == '2' && mt[4] == false) {
       mt[4] = true;
    }else mt[4] = false;
  }
  if (mt[0]) {
    back1();   // вращаем оба моторчика вперёд
    back2();
  }
  if (mt[1]) {
    forward1(); 
    forward2();   // вращаем оба моторчика вперёд
  }
  if (mt[2]) {
    forward1(); 
    back2();    
  }
  if (mt[3]) {
    forward2();
   back1(); 
  }
  if (mt[4]) {
    stop12();
  }
  Serial.println(incomingByte);
}
